//trigBoard Sample Code using PushSafer
// 12/16/18  Kevin Darrah
// RELEASED

// Includes - may not all be needed
#include <FS.h>                   //this needs to be first, or it all crashes and burns...
#include <ESP8266WiFi.h>          //https://github.com/esp8266/Arduino
#include <DNSServer.h>
#include <ESP8266WebServer.h>
#include <WiFiManager.h>          //https://github.com/tzapu/WiFiManager
#include <ESP8266HTTPClient.h>
#include <WiFiClientSecure.h>
#include <ArduinoJson.h>          //https://github.com/bblanchon/ArduinoJson
#include <ESP8266mDNS.h>
#include <WiFiUdp.h>
//#include <ArduinoOTA.h>
#include <ESP8266HTTPUpdateServer.h>
#include <Pushsafer.h>
//http://trigboard.local/update

// PINS!!!
#define LEDpin 0 // this is the on-board LED - write this LOW to turn on
#define DONEpin 15  // write this PIN HIGH to kill your own power
#define EXTWAKEpin 16 // check this pin right when you boot up to see if the external switch woke you up - will be LOW if externally woken

//FUNCTIONS
void saveConfigCallback ();
boolean readFile();
boolean WiFiConnection();
void checkTrigger();
void longPress();
void pushSafer();

//globals for credentials
char tokenKey[100];
char trigBoardName[40];
char triggerMessage[100];
boolean resetFlag = false;

//flag for saving data
bool shouldSaveConfig = false;

char batteryBuf[5] = "";// used to convert float to a char array
boolean externalWake = false;// to figure out who woke up the board
float batteryVoltage = 0;
float batteryThreshold = 3.4;

void setup() {
  Serial.begin(115200);//debug
  checkTrigger();

  if (externalWake || batteryVoltage < batteryThreshold) {// only if external trigger was fired or the battery is low, send a push
    if (readFile())
      if (WiFiConnection())
        pushSafer();
  }

  // Go back to sleep
  for (int i = 0; i < 10; i++) {
    digitalWrite(DONEpin, HIGH);
    delay(100);
    digitalWrite(DONEpin, LOW);
    delay(100);
  }

  // or if you hold the wake button, you'll end up here
  longPress();

}

void loop() {// we're done, so kill power.  All code should run in void setup()
  digitalWrite(DONEpin, HIGH);
  delay(5000);
  digitalWrite(DONEpin, LOW);
  delay(5000);
}
